var $ = jQuery;
$(function() {
	var def_input_border_color = '#d7d7d7';
	var SubjectSelectObj = $('select.SelectSubject');
	var SubjectInputObj = $('input.InputSubject ');
	var GradeSelectObj = $('select.SelectGrade');
	var ExamTypeRadio = $('input.ExamType');

	// Изменения базовых параметров дисциплины
    $(".AddDiscipline").click(function()
    {
    	var ErrCount = 0;
		var thisObj = $(this);
    	$(this).attr("disabled", true);
		var BonusRate = $(".BonusRate").prop("checked");

		var SubjectID = SubjectSelectObj.val();
		if (SubjectID == null || SubjectID == undefined || SubjectID == '0') {
			SubjectInputObj.css('border-color', 'red');
			ErrCount++;
		}

		var GradeID = parseInt(GradeSelectObj.val());
		if (GradeID <= 0 || isNaN(GradeID)) {
			GradeSelectObj.css('border-color', 'red');
			ErrCount++;
		}

		var ExamType = ExamTypeRadio.filter(':radio:checked').val();
		if (ExamType == undefined) {
			ExamTypeRadio.first().parent().parent().css('background-color', '#f2b4b4');
			ErrCount++;
		}

		if (ErrCount == 0)
			$.post(
				URLdir + 'handler/map/AddDiscipline',
				{
					'Grade': GradeID,
					'SubjectID': SubjectID,
					'BonusRate': BonusRate,
					'ExamType': ExamType,
					'LectionCount': $('input.InputLectionCount').val(),
					'LabCount': $('input.InputLabCount').val(),
					'PracticeCount': $('input.InputPracticeCount').val(),
					'FacultyID': $('select.SelectFaculty').val()
				},
				function(data)
				{
					data = $.parseJSON(data);
					if(data.success === true) {
						EventInspector_ShowMsg('Дисциплина добавлена', 'success');
						setTimeout('location.replace("'+URLdir+'discipline/structure/'+data.DisciplineID+'")', 800); 
					} else {
						thisObj.removeAttr('disabled');
						EventInspector_ShowMsg('Ошибка при добавлении дисциплины', 'error');
					}
				}
			);
		else {
			thisObj.removeAttr('disabled');
			EventInspector_ShowMsg('Ошибка при добавлении дисциплины', 'error');
		}
    });

	SubjectSelectObj.change(function(){
		if (parseInt($(this).val()) > 0)
			SubjectInputObj.css('border-color', def_input_border_color);
	});

	GradeSelectObj.change(function(){
		if (parseInt($(this).val()) > 0)
			GradeSelectObj.css('border-color', def_input_border_color);
	});

	ExamTypeRadio.change(function(){
		var ExamType = $(this).val();
		if (ExamType == 'exam' || ExamType == 'credit')
			$(this).parent().parent().css('background-color', '#fff');
	});
	
	// В inputs часы (практ., лекц., лаб.) писать можно только цифры
	
	$('input.InputLectionCount').keydown(function(event) {
		KeyDownOnlyNumber(event);
    });
	
	$('input.InputLabCount').keydown(function(event) {
		KeyDownOnlyNumber(event);
    });
	
	$('input.InputPracticeCount').keydown(function(event) {
		KeyDownOnlyNumber(event);
    });
	
});