var $ = jQuery;
$(function() {
var jSubmodulePrototype = $($.parseHTML(
								'<div class="subModule">\
									<div class="name">\
										<input type="text" class="inputName SubmoduleName" value="" placeholder="Наименование мероприятия">\
									</div>\
									<div class="currentControl"><input type="text" class="inputCredit inputCurrentControl" value="0"></div>\
									<div class="landmarkControl"><input type="text" class="inputCredit inputLandmarkControl" value="0"></div>\
									<div class="actions">\
										<div class="deleteSubModule icon delete"></div>\
										<div class="downSubModule icon down"></div>\
										<div class="upSubModule icon up"></div>\
									</div>\
								</div>'
							));

var	jModulePrototype 	= $($.parseHTML(
								'<div class="moduleGroup">\
									<div class="moduleHead">\
										<div class="name">\
											<input type="text" class="inputName ModuleName" value="" placeholder="Наименование модуля">\
										</div>\
										<div class="currentControl">0</div>\
										<div class="landmarkControl">0</div>\
										<div class="actions">\
											<div class="deleteModule icon delete"></div>\
											<div class="downModule icon down"></div>\
											<div class="upModule icon up"></div>\
										</div>\
									</div>\
									<div class="subModules"></div>\
									<button class="addSubModule">Добавить мероприятие</button>\
								</div>'
							)); 

var jConfirmPrototype 	= $($.parseHTML(
								'<div class="confirmDeleteDiv">Уверены? <span class="confirmDeleteModule">Да</span> <span class="cancel">Нет</span></div>'
							));

	// Шаблон мероприятия
	function GetSubModuleTmp(){
		return jSubmodulePrototype.clone();
	}

	// Шаблон модуля
	function GetModuleTmp() {
		var ret = jModulePrototype.clone();
		ret.children('div.subModules').append(GetSubModuleTmp());
		return ret;
	};

	// Подсчет текущего контроля
	function CountCurrentControl(subModulesDiv){
		var maxCredits = 0;
		$('input.inputCurrentControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0);
		});
		subModulesDiv.prev().children('div.currentControl').text(maxCredits);
	}
	// Подсчет рубежного контроля
	function CountLandmarkControl(subModulesDiv){
		var maxCredits = 0;
		$('input.inputLandmarkControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0); 
		});
		subModulesDiv.prev().children('div.landmarkControl').text(maxCredits);
	}
	

	function ChangeSubmoduleMaxAndControl(thisObj, ID, NewMaxRate, ControlType) { 
		$.post(
			URLdir + 'handler/map/ChangeSubmoduleMaxAndControl',
			{
				'SubmoduleID': ID,
				'MaxRate': NewMaxRate,
				'ControlType': ControlType
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true)
					EventInspector_ShowMsg('Max балл мероприятия изменен', 'success');
				else EventInspector_ShowMsg('Ошибка при изменении max балла', 'error');
				thisObj.removeAttr('disabled');
			}
		);
	}
	
	// Установить новый max балл
	function SetNewRateAndControl(thisObj, OldMaxRate) {
		// DIV с мероприятиями для данного модуля
		var subModulesDiv = thisObj.parent().parent().parent();
		// ID мероприятия
		var ID = thisObj.parent().parent().attr('id');
		var NewMaxRate = 0;
		if (thisObj.val().length > 0 )
			NewMaxRate = parseInt(thisObj.val());
		
		// Ограничение 100 баллов
		var MaxSumRate = 100;
		if ($('div.ExamModule').first().length > 0) MaxSumRate = 60;
		
		var currentControl = 0;
		$('div.moduleHead').children('div.currentControl').each(function(){
			currentControl += parseInt($(this).text());
		});
		
		var landmarkControl = 0;
		$('div.moduleHead').children('div.landmarkControl').each(function(){
			landmarkControl += parseInt($(this).text());
		});
		
		var subtract = 0;
		if (thisObj.parent().attr('class').indexOf('landmarkControl') + 1 > 0)
			subtract = parseInt(thisObj.parent().siblings('.currentControl').children().val());
		if (thisObj.parent().attr('class').indexOf('currentControl') + 1 > 0)
			subtract = parseInt(thisObj.parent().siblings('.landmarkControl').children().val());
			
		if (currentControl + landmarkControl + NewMaxRate - subtract - OldMaxRate > MaxSumRate) {
			if (NewMaxRate == 0)
				thisObj.val('0');
			else {
				EventInspector_ShowMsg('Сумма баллов превышает максимум', 'error');
				thisObj.val(OldMaxRate);
				thisObj.removeAttr('disabled')
				return 0;
			}
		}
		
		// Меняем max балл
		if (NewMaxRate != OldMaxRate) {

			ControlType = 'CurrentControl'; // По-умолчанию 
			if ((thisObj.parent().attr('class')).indexOf('landmarkControl') + 1 > 0)
				ControlType = 'LandmarkControl';


			ChangeSubmoduleMaxAndControl(thisObj, ID, NewMaxRate, ControlType);
			
			// Счетчик баллов
			var RateIndicarot = currentControl + landmarkControl + NewMaxRate - subtract - OldMaxRate;
			if ($('div.ExamModule').length > 0) RateIndicarot += 40;
			$('div.RateIndicatorDIV span.RateIndicator').html(RateIndicarot);
			
			if (ControlType == 'CurrentControl')
				thisObj.parent().parent().find('div.landmarkControl').children('input.inputLandmarkControl').val('0');
				
			if (ControlType == 'LandmarkControl')
				thisObj.parent().parent().find('div.currentControl').children('input.inputCurrentControl').val('0');
		} else thisObj.removeAttr('disabled');
		
		// Подсчет текущего и рубежного контроля после изменений
		CountCurrentControl(subModulesDiv);
		CountLandmarkControl(subModulesDiv);
	}
	
	// Поменять местами два модуля
	function SwapModuleOrder(jModule1, jModule2) {
		$.post(
			URLdir + 'handler/map/SwapModuleOrder',
			{
				'ModuleID1': jModule1.attr('id'),
				'ModuleID2': jModule2.attr('id')
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					EventInspector_ShowMsg('Модули поменяли порядок', 'success');
					jModule1.insertBefore(jModule2);
				}
				else EventInspector_ShowMsg('Ошибка при изменении порядка модулей', 'error');
			}
		);
	}
	
	// Поменять местами два мероприятия
	function SwapSubmoduleOrder(jSubmodule1, jSubmodule2) {
		$.post(
			URLdir + 'handler/map/SwapSubmoduleOrder',
			{
				'SubmoduleID1': jSubmodule1.attr('id'),
				'SubmoduleID2': jSubmodule2.attr('id')
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					EventInspector_ShowMsg('Мероприятия поменяли порядок', 'success');
					jSubmodule1.insertBefore(jSubmodule2);
				}
				else 
					EventInspector_ShowMsg('Ошибка при изменении порядка мероприятий', 'error');
			}
		);
	}
	
//-------------------------------------------------------------------------------------------------------------------------------------------------
	
	// Переместить вверх МОДУЛЬ
    $(".moduleList").on('click', '.upModule', function(){
        var parentDIV = $(this).parent().parent().parent();
		var moduleGroupDiv = parentDIV.prev('div.moduleGroup');
		if (moduleGroupDiv.length > 0) {
			SwapModuleOrder(parentDIV, moduleGroupDiv);
		}
    });
	
	// Переместить вниз МОДУЛЬ
    $(".moduleList").on('click', '.downModule', function(){
        var parentDIV = $(this).parent().parent().parent();
		var moduleGroupDiv = parentDIV.next('div.moduleGroup');
		if (moduleGroupDiv.length > 0) {
			SwapModuleOrder(moduleGroupDiv, parentDIV);
		}
    });
	
	// Переместить вверх мероприятие
    $(".moduleList").on('click', '.upSubModule', function(){
        var parentDIV = $(this).parent().parent();
		var subModule = parentDIV.prev('div.subModule');
		if (subModule.length > 0) {
			SwapSubmoduleOrder(parentDIV, subModule);
		}
    });
	
	// Переместить вниз мероприятие
    $(".moduleList").on('click', '.downSubModule', function(){
        var parentDIV = $(this).parent().parent();
		var subModule = parentDIV.next('div.subModule');
		if (subModule.length > 0) {
			SwapSubmoduleOrder(subModule, parentDIV);
		}
    });
	
	// Добавить модуль
	$('.addModule').click(function(){
		var thisObj = $(this);
    	$(this).attr("disabled", true);
		var OrderNum = $('div.moduleGroup', 'div.moduleList').last().index('.moduleGroup') + 2;
		$.post(
			URLdir + 'handler/map/AddModule',
			{
				'DisciplineID': DisciplineID
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					var place = $('.moduleList').children('.moduleGroup').last();
					if (place.length > 0) 
						place.after(GetModuleTmp());
					else {
						$('div.moduleList').prepend(GetModuleTmp());
					}
						
					// К добавленному модулю добавляем ID
					var thisModuleDIV = $('div.moduleGroup').eq(OrderNum - 1);
					thisModuleDIV.attr('id', data.ModuleID);
					// К добавленному в модуль мероприятию добавляем ID
					thisModuleDIV.children('div.subModules').children('div.subModule').eq(0).attr('id', data.SubmoduleID);
					EventInspector_ShowMsg('Модуль добавлен', 'success');
				} else 
					EventInspector_ShowMsg('Ошибка при добавлении модуля', 'error');
				thisObj.removeAttr('disabled');
			}
		);
		
		$('.empty').remove();
		
	});
	
	// Добавить мероприятие
	$('div.moduleList').on('click', 'button.addSubModule', function(){
		var thisObj = $(this);
    	$(this).attr("disabled", true);
		var ModuleID = $(this).parent().attr('id');
		var SubmodulesDIV = $(this).siblings('div.subModules');
		var OrderNum = SubmodulesDIV.children('div.subModule').last().index() + 2;
		$.post(
			URLdir + 'handler/map/AddSubmodule',
			{
				'ModuleID': ModuleID
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					// К добавленному мероприятию добавляем ID
					SubmodulesDIV.append(GetSubModuleTmp());
					SubmodulesDIV.children('div.subModule').eq(OrderNum - 1).attr('id', data.SubmoduleID);
					EventInspector_ShowMsg('Мероприятие добавлено', 'success');
				} else EventInspector_ShowMsg('Ошибка при добавлении мероприятия', 'error');
				thisObj.removeAttr('disabled');
			}
		);
	});


	
	// Удалить модуль
	$('.moduleList').on('click', '.deleteModule', function(){
		$(this).parent().css('display', 'none');
		$(this).parent().parent().append(jConfirmPrototype.clone());

	});
	
	// Подтверждение при удаление модуля
	$('.moduleList').on('click', '.confirmDeleteModule', function(){
		var thisObj = $(this);

		$.post(
			URLdir + 'handler/map/DeleteModule',
			{
				'ModuleID': $(this).parent().parent().parent().attr('id'),
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					thisObj.parent().parent().parent().remove();
					
					var c = 0;
					$('div.moduleGroup')
						.children('div.moduleHead')
						.children('div.currentControl')
						.each(function(){
							c += parseInt($(this).text());
						});
						
					var l = 0;
					$('div.moduleGroup')
						.children('div.moduleHead')
						.children('div.landmarkControl')
						.each(function(){
							l += parseInt($(this).text());
						});
					
					var e = 0;
					if ($('div.ExamModule').length > 0) e = 40;
					
					$('span.RateIndicator').html(c + l + e);

					if ($('div.moduleGroup').length == 0)
						$('.moduleList').prepend('<div class="empty"><p class="notification">Модули отсутствуют</p></div>'); // Показываем 'Модули отсутствуют'
						
					EventInspector_ShowMsg('Модуль удален', 'success');
				}
				else EventInspector_ShowMsg('Ошибка при удаление модуля', 'error');
			}
		);

	});
	
	// Удалить мероприятие
	$('.moduleList').on('click', '.deleteSubModule ', function(){
		$(this).parent().css('display', 'none');
		$(this).parent().parent().append('<div class="confirmDeleteDiv">Уверены? <span class="confirmDeleteSubModule">Да</span> <span class="cancel">Нет</span></div>');
	});
	
	// Подтверждение при удаление мероприятия
	$('.moduleList').on('click', '.confirmDeleteSubModule ', function(){
		var thisObj = $(this);
		var subModulesDiv = $(this).parent().parent().parent();
		CountCurrentControl(subModulesDiv);
		CountLandmarkControl(subModulesDiv);

		$.post(
			URLdir + 'handler/map/DeleteSubmodule',
			{
				'SubmoduleID': $(this).parent().parent().attr('id')
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					var sub = thisObj.parent().parent();
					var mod = sub.parent().parent().find('div.moduleHead');
					// get old submodule values
					var dif1 = parseInt(sub.find('div.currentControl').find('input').val());
					var dif2 = parseInt(sub.find('div.landmarkControl').find('input').val());
					
					// change module header
					var old = parseInt(mod.find('div.currentControl').html());
					mod.children('div.currentControl').html(old - dif1);

					old = parseInt(mod.find('div.landmarkControl').html());
					mod.children('div.landmarkControl').html(old - dif2);

					// change sum rate
					var RateIndicator = $('span.RateIndicator');
					old = RateIndicator.html();
					RateIndicator.html(old - dif1 - dif2);
					
					thisObj.parent().parent().remove();
					EventInspector_ShowMsg('Мероприятие удалено', 'success');
				}
				else EventInspector_ShowMsg('Ошибка при удалении мероприятия', 'error');
			}
		);
	});
	
	// Отмена удаления модулей/мероприятий
	$('.moduleList').on('click', '.cancel ', function(){
		$(this).parent().parent().children('div.actions').css('display', 'block');
		$(this).parent().remove();
	});
	
	// Поменять название модуля
	var ModuleName;
	$('div.moduleList').on('focusin', 'input.ModuleName', function(){
		ModuleName = $(this).val();
	});
	$('div.moduleList').on('focusout', 'input.ModuleName', function(){
		var thisObj = $(this);
    	$(this).attr("disabled", true);
		var NewModuleName = $(this).val();
		if (NewModuleName != '' && ModuleName != NewModuleName) {
			var ID = $(this).parent('').parent('').parent('').attr('id');
			$.post(
				URLdir + 'handler/map/ChangeModuleName',
				{
					'ModuleID': ID,
					'ModuleName': NewModuleName
				},
				function(data){
					data = $.parseJSON(data);
					if(data.success === true)
						EventInspector_ShowMsg('Имя модуля изменено', 'success');
					else EventInspector_ShowMsg('Ошибка при изменении имени модуля', 'error');
					thisObj.removeAttr('disabled');
				}
			);
		} else thisObj.removeAttr('disabled');
	});
	$('.moduleList').on('keydown', '.ModuleName', function(e){
		if(e.keyCode==13){
			$('.ModuleName').trigger('focusout');
		}
	});
	
	// Поменять название мероприятие
	var SubmoduleName;
	$('div.moduleList').on('focusin', 'input.SubmoduleName', function(){
		SubmoduleName = $(this).val();
	});
	$('div.moduleList').on('focusout', 'input.SubmoduleName', function(){
		var thisObj = $(this);
    	$(this).attr("disabled", true);
		var NewSubmoduleName = $(this).val();
		if (NewSubmoduleName != '' && SubmoduleName != NewSubmoduleName) {
			var ID = $(this).parent('div').parent('div').attr('id');
			$.post(
				URLdir + 'handler/map/ChangeSubmoduleName',
				{
					'SubmoduleID': ID,
					'SubmoduleName': NewSubmoduleName
				},
				function(data){
					data = $.parseJSON(data);
					if(data.success === true)
						EventInspector_ShowMsg('Имя мероприятия изменено', 'success');
					else EventInspector_ShowMsg('Ошибка при изменении имени мероприятия', 'error');
					thisObj.removeAttr('disabled');
				}
			);
		} else thisObj.removeAttr('disabled');
	});
	$('div.moduleList').on('keydown', 'input.SubmoduleName', function(e){
		if(e.keyCode==13){
			$('.SubmoduleName').trigger('focusout');
		}
	});
	
	// При записи в input текущий контроль
	// При фокусе
	var OldMaxRate = 0;
	$('div.moduleList').on('focusin', 'input.inputCurrentControl', function(){
		OldMaxRate = $(this).val();
	});
	// При потери фокуса
	$('div.moduleList').on('focusout', 'input.inputCurrentControl', function(){
    	$(this).attr("disabled", true);
		SetNewRateAndControl($(this), OldMaxRate);
	});
	
	// При записи в input рубежный контроль
	// При фокусе
	var OldMaxRate = 0;
	$('div.moduleList').on('focusin', 'input.inputLandmarkControl', function(){
		OldMaxRate = $(this).val();
	});
	// При потере фокуса
	$('div.moduleList').on('focusout', 'input.inputLandmarkControl', function(){
		$(this).attr("disabled", true);
		SetNewRateAndControl($(this), OldMaxRate);
	});
	
	// В inputCredit (где баллы вводить) разрешаем вводить только цифры
	$("div.moduleList").on('keydown', 'input.inputCredit', function(event) {
        KeyDownOnlyNumber(event);
    });


});
